=== daemon/tools/build-system/launchpad/sflphone-kde/debian/control ===
Source: sflphone-kde
Section: kde
Priority: optional
Maintainer: Emmanuel Milou <emmanuel.milou@savoirfairelinux.com>
Build-Depends: debhelper (>= 5.0), cdbs, kdelibs5-dev, cmake, kdepimlibs5-dev, libboost-dev, libx11-dev, libqt4-opengl-dev,
Homepage: http://www.sfphone.org/

Package: sflphone-kde
Architecture: any
Depends: sflphone-daemon-video (=${source:Version}), ${shlibs:Depends}, ${misc:Depends}, libqt4-dbus, libqt4-opengl
Provides: sflphone-client-kde
Replaces: sflphone-client-kde
Description:KDE client for the sflphone-daemon SIP/IAX softphone
