=== daemon/tools/build-system/launchpad/sflphone-daemon-video/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DH_OPTIONS

package=sflphone-daemon-video

CXX = g++-4.0
CFLAGS = -Wall -g
DEB_INSTALL_MANPAGES_sflphone_daemon_video = sflphoned.1

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	# build iax and opendht with contrib since they are not packaged
	cd contrib && mkdir -p native && cd native && ../bootstrap && make .iax && make .dht && cd ../..
	./autogen.sh
	./configure --prefix=/usr
	touch configure-stamp

#Architecture
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp

    # Add here commands to compile the arch part of the package.
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp configure-stamp
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean

ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	dh_clean

install: install-arch

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s
	dh_installdirs -s
	# Add here commands to install the arch part of the package into
	# debian/tmp.
	$(MAKE) DESTDIR=$(CURDIR)/debian/$(package) install
	rm -rf $(CURDIR)/debian/$(package)/usr/include
	dh_install -s

binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_installman
	dh_link
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

override_dh_strip:

binary: binary-arch
.PHONY: build clean binary-arch binary install install-arch configure override_dh_strip
